#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"Caption",;
"CommandLine",;
"CreationClassName",;
"CreationDate",;
"CSCreationClassName",;
"CSName",;
"Description",;
"ExecutablePath",;
"ExecutionState",;
"Handle",;
"HandleCount",;
"InstallDate",;
"KernelModeTime",;
"MaximumWorkingSetSize",;
"MinimumWorkingSetSize",;
"Name",;
"OSCreationClassName",;
"OSName",;
"OtherOperationCount",;
"OtherTransferCount",;
"PageFaults",;
"PageFileUsage",;
"ParentProcessId",;
"PeakPageFileUsage",;
"PeakVirtualSize",;
"PeakWorkingSetSize",;
"Priority",;
"PrivatePageCount",;
"ProcessId",;
"QuotaNonPagedPoolUsage",;
"QuotaPagedPoolUsage",;
"QuotaPeakNonPagedPoolUsage",;
"QuotaPeakPagedPoolUsage",;
"ReadOperationCount",;
"ReadTransferCount",;
"SessionId",;
"Status",;
"TerminationDate",;
"ThreadCount",;
"UserModeTime",;
"VirtualSize",;
"WindowsVersion",;
"WorkingSetSize",;
"WriteOperationCount",;
"WriteTransferCount" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_Process.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_Process",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("Caption"),;
     oService:getProperty("CommandLine"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("CreationDate"),;
     oService:getProperty("CSCreationClassName"),;
     oService:getProperty("CSName"),;
     oService:getProperty("Description"),;
     oService:getProperty("ExecutablePath"),;
     oService:getProperty("ExecutionState"),;
     oService:getProperty("Handle"),;
     oService:getProperty("HandleCount"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("KernelModeTime"),;
     oService:getProperty("MaximumWorkingSetSize"),;
     oService:getProperty("MinimumWorkingSetSize"),;
     oService:getProperty("Name"),;
     oService:getProperty("OSCreationClassName"),;
     oService:getProperty("OSName"),;
     oService:getProperty("OtherOperationCount"),;
     oService:getProperty("OtherTransferCount"),;
     oService:getProperty("PageFaults"),;
     oService:getProperty("PageFileUsage"),;
     oService:getProperty("ParentProcessId"),;
     oService:getProperty("PeakPageFileUsage"),;
     oService:getProperty("PeakVirtualSize"),;
     oService:getProperty("PeakWorkingSetSize"),;
     oService:getProperty("Priority"),;
     oService:getProperty("PrivatePageCount"),;
     oService:getProperty("ProcessId"),;
     oService:getProperty("QuotaNonPagedPoolUsage"),;
     oService:getProperty("QuotaPagedPoolUsage"),;
     oService:getProperty("QuotaPeakNonPagedPoolUsage"),;
     oService:getProperty("QuotaPeakPagedPoolUsage"),;
     oService:getProperty("ReadOperationCount"),;
     oService:getProperty("ReadTransferCount"),;
     oService:getProperty("SessionId"),;
     oService:getProperty("Status"),;
     oService:getProperty("TerminationDate"),;
     oService:getProperty("ThreadCount"),;
     oService:getProperty("UserModeTime"),;
     oService:getProperty("VirtualSize"),;
     oService:getProperty("WindowsVersion"),;
     oService:getProperty("WorkingSetSize"),;
     oService:getProperty("WriteOperationCount"),;
     oService:getProperty("WriteTransferCount") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_Process"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   objWMIServices:Destroy()
   objWMIServices := NIL

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_Process.TXT","Notepad.exe",.T.)

RETURN
